package control;
import java.awt.Component;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import view.IView;
import view.View; // technisch bedingt: addMouseListener ist nicht in der Schnittstelle

import model.BesetztException;
import model.IModel;
import model.Spieler;

/** Control mit Maussteuerung fr Gobang mit MVC
 * @author Prof. Dr. Andreas Solymosi, Beuth-Hochschule fr Technik, (c) 2012, solymosi@tfh-berlin.de
 * @version 5/1/12 
 */
public class Control {
	final private IModel model;
	final private View view;
	public Control(final IModel m, final IView v) {
		this.model = m;
		this.view = (View)v;
		final int hhe = view.brettgre().height, 
			breite = view.brettgre().width;
		view.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent mausereignis) {
				if (model.sieger() != Spieler.LEER) { // Spiel ist zu Ende
					model.start(); // Neuanfang
				} else {				
					Component komponente = mausereignis.getComponent();
					try {
						model.steinSetzen(mausereignis.getX() / (komponente.getWidth() / breite), mausereignis.getY() / (komponente.getHeight() / hhe));
					} catch (BesetztException e) {
						// view.feldBesetzt(); // nur fr Testzwecke
						return;
					}
				}
				view.neuZeichnen();
			}
		});
	}
}
		
